/* murat demirsoy-e1061548 */
#include "Loader.h"



LinkingLoader Loader;

SourceFile SrcFile;

SourceLine SrcLine;

ExternalSymbolTable ExtTable;

MemoryClass Memory;

Errors Error;

/************************ the end *********************************/

inline char SourceFile::Open(char *mode) {

if ( (_SrcFile=fopen(SrcFileName,mode))!=NULL) return SUCCESSFUL;

return FAIL;
}

/************************ the end *********************************/

inline char SourceFile::Close() {

if ( (fclose(_SrcFile))== 0 ) return SUCCESSFUL;
_SrcFile=NULL;

return FAIL;
}

/************************ the end *********************************/

inline char SourceFile::Read(char *line) {

if ( fgets(line,MAX_LINE_LENGTH,_SrcFile)== NULL) return FAIL;

return SUCCESSFUL;

}

/************************ the end *********************************/

inline void SourceFile::SetFileName(char *srcfile) {

if (strlen(srcfile)<MAX_SRCFILENAME_LENGTH) strcpy(SrcFileName,srcfile);
else printf("filename must no exeed %d characters\n",MAX_SRCFILENAME_LENGTH);

}

/************************ the end *********************************/

inline void BaseRecord::_ToUpper() {
	for (int i=0; _Record[i]; i++)
		if (_Record[i]>='a' && _Record[i]<='z') _Record[i]=_Record[i] + 'A'-'a';
}

/************************ the end *********************************/

inline char BaseRecord::Read() {
	int i=0;
	int exist=0;

	_ColCtr=0;
	_Record[0]=0;
		
	while(SrcLine._Line[i+1]!='\n') if (i< MAX_RECORD_LENGTH) { _Record[i]= SrcLine._Line[i+1]; i++; exist=1;}
                                                else break;

	_Record[i]=NULL;
	
	if (exist) _ToUpper();
	else return _Error(-1);
	
	return SUCCESSFUL;
}

/************************ the end *********************************/

char *BaseRecord::AsChar(int count) {
	int i;
	char *chars;
	
	chars=(char *)malloc(count*sizeof(char));	
	for(i=0;i<count;i++)
		if (_Record[_ColCtr]==' ' || _Record[_ColCtr]=='\n') 
		{
		   _ColCtr += count-i;
			break;
		}
		else chars[i]=_Record[_ColCtr++];
	chars[i]='\0';

	return chars;
}

/************************ the end *********************************/

int BaseRecord::AsInt(int count) {

	return HexToInt(AsChar(count));
}


/************************ the end *********************************/

char BaseRecord::Finished() {
	
	if (_Record[_ColCtr]=='\0') return TRUE;

	return FALSE;
}




/************************ the end *********************************/

inline Errors::Errors() {
	_ErrNo=-1;
	for(int i=0;i<ERROR_TABLE_LENGTH;i++)
		_ErrTable[i]=(char *)malloc(MAX_ERR_MESSAGE_SIZE*sizeof(char));
	
	 strcpy(_ErrTable[5], "Out of memory");
	 strcpy(_ErrTable[4], "Symbol not found");
	 strcpy(_ErrTable[3],"Invalid Record");
	 strcpy(_ErrTable[12],"Redeclaration of symbol");
	 strcpy(_ErrTable[2],"Header Required");
	 
}

/************************ the end *********************************/

inline Errors::~Errors() {

}


/************************ the end *********************************/

inline void Errors::SetErr(int err,char *token) {
	_ErrNo=err;

	if (token!=NULL) strncpy(_ErrToken,token,MAX_RECORD_LENGTH-1);
}

/************************ the end *********************************/

inline void Errors::Print() {
    if (_ErrNo >=0)
	{
	if (_ErrNo >= ERROR_TABLE_LENGTH ) printf("Line %d: unknown error\n",Loader.Line);
	else if (strcmp(_ErrToken,"")!=0) printf("Line %d :\"%s\": %s\n",Loader.Line,_ErrToken,_ErrTable[_ErrNo]); 
	     else printf("Line %d : %s\n",Loader.Line,_ErrTable[_ErrNo]); 

	}
	_ErrNo=-1;
	 strcpy(_ErrToken,"");
}

/************************ the end *********************************/

inline char BaseRecord::_Error(int errno) {
	
	Error.SetErr(errno,_Record);
	Error.Print();
	exit(1);
	
	return ERROR;
}


inline char SourceLine::New() {


	Loader.Line++;
	if (SrcFile.Read(_Line)==FAIL) return FAIL;

	if (_Line[0]=='H') return HEADER;
	if (_Line[0]=='D') return DEFINE;
	if (_Line[0]=='R') return REFERENCE;
	if (_Line[0]=='T') return TEXT;
	if (_Line[0]=='M') return MODIFY;
	
	return FAIL;
}



/************************ the end *********************************/


char * IntToHex(int address,char length) {
	char *hexaddress,*temp;
	int i,k,v;

	hexaddress=(char *)malloc((length)*sizeof(char));
	temp=(char *)malloc((length)*sizeof(char));

	for (i=0;address>=16;address/=16,i++) 
		temp[i]=((v=address%16)<10)?(v+'0'):(v+'A'-10);
	temp[i++]=(address<10)?(address+'0'):(address+'A'-10);

	if (i<=length)
	{
		for(k=i;k<length;k++) hexaddress[k-i]='0';
		for(k=length-i,i=i-1;i>=0;i--,k++) hexaddress[k]=temp[i];
	}
	else for(k=0;k<length;k++) hexaddress[k]='X';

	hexaddress[k]='\0';

	return hexaddress;


}

/************************ the end *********************************/

int HexToInt(char *hex) {
	int i,k,lh,r,result;

	lh=strlen(hex);
	for(result=0,i=lh-1;i>=0;i--)
	{
		r=(hex[i]>='A' && hex[i]<='F')?(hex[i]-'A'+10):(hex[i]-'0');
	
	/*
		if (hex[i]>='A' && hex[i]<='F') r=(hex[i]-'A'+10);
		else if (hex[i]>='0'&& hex[i]<='9') r=(hex[i]-'0');
		else return 0;
*/
		for(k=0;k<lh-i-1;k++) r*=16;
		result+=r;
	}

	return result;
}


/************************ Class Header *********************************/

inline void Header::_SectionName(char *progname) {
	strcpy(progname,AsChar(6));
}

/************************ the end *********************************/

inline int Header::_SectionAddress() {

	return AsInt(6);
}

/************************ the end *********************************/

inline int Header::_SectionLength() {

	return AsInt(6);
}

/************************ the end *********************************/

inline char Header::Pass1() {

	_SectionName(Loader.CurSection->Name);
	 Loader.CurSection->Address=_SectionAddress();
	 Loader.CurSection->Length= _SectionLength();
	

	if (ExtTable.Insert(Loader.CurSection->Name,
		               Loader.StartAddress,
					   Loader.CurSectNumber)==FAIL) return _Error(12);

	return SUCCESSFUL;
	
}


/************************ the end *********************************/


char Define::_NextSymbol() {
	
	if (Finished()) return FAIL;

	strcpy(_Symbol,AsChar(6));
   _Address=AsInt(6);

	return SUCCESSFUL;
}


/************************ the end *********************************/


char Define::Pass1() {


	while(_NextSymbol()!=FAIL)
	{
		if (ExtTable.Insert(_Symbol,Loader.StartAddress+
			                 (_Address - Loader.CurSection->Address) ,
							 Loader.CurSectNumber)==FAIL) return _Error(12);/***return mu devammi?????****/
	}

	return SUCCESSFUL;
}

/************************ the end *********************************/

char Text::Pass2() {
	int numbytes,Address;
	int address;

	address=AsInt(6);

	Address=Loader.StartAddress+(address-Loader.CurSection->Address);

	numbytes=AsInt(2); 

	Memory.Write(Address,2*numbytes,AsChar(2*numbytes)); //_Record[8]);

	return 0;
}

/************************ the end *********************************/

char Modify::Pass2() {
	int address,numhalfbytes,val;
	char operatr;
	char ref[6],hexval[6];
	ExternalSymbolData *symptr;

	address=AsInt(6);

	address=Loader.StartAddress+(address-Loader.CurSection->Address);

	numhalfbytes=AsInt(2); 

	operatr=*AsChar(1);
	strcpy(ref,AsChar(6));

	if ((symptr=ExtTable.Search(ref))==NULL) Error.SetErr(4,ref);
	else 
	{
		strcpy(hexval,Memory.Read(address,numhalfbytes));
		val=HexToInt(hexval) +symptr->Address;
		strcpy(hexval,IntToHex(val,numhalfbytes));
		if (operatr=='+') Memory.Write(address,numhalfbytes,hexval);
		else if (operatr=='-') Memory.Write(address,numhalfbytes,hexval);
	         else printf("error in modify::pass2 \n");
	}

	return 0;
}

/************************ the end *********************************/

void MemoryClass::Init() {

	_Memory=(char (*)[32])malloc(((EndAddress-StartAddress)/16+1)*sizeof(char[32]));

	 for(int i=0;i<=(EndAddress-StartAddress)/16;i++)
		 for(int j=0; j<32; j++)
			 _Memory[i][j]='x';
}


/************************ the end *********************************/

void MemoryClass::Write(int address,char numhalfbytes,char *data) {
	int i,k=1,row,col;

	printf("%s :",IntToHex(address-address%16,4));

	address-=StartAddress;

	row=address/16;
	col=(address%16)*2;
	for(i=0;i<numhalfbytes;i++,col++)
	{
		if (col>=32) { col=0; row++; k++; }
		if (row>100) Error.SetErr(5,0);
		else _Memory[row][col]=data[i];
	}

}

/************************ the end *********************************/

char *MemoryClass::Read(int address,char numhalfbytes) {
	char *data;
	int i,row,col;

	address-=StartAddress;

	data=(char *)malloc(numhalfbytes*sizeof(char));
    
	row=address/16;
	col=(address%16)*2;
	for(i=0;i<numhalfbytes;i++,col++)
	{
		if (col>=32) { col=0; row++; }
		if (row>100) Error.SetErr(5,0);
		else data[i]=_Memory[row][col];
	}

	data[i]='\0';

	return data;

}

/************************ the end *********************************/


void MemoryClass::Print() {
	int j;

	for(int i=0;i<=(EndAddress-StartAddress)/16;i++)
	{
		printf("%s : ",IntToHex(i*16+StartAddress,4) );
		for(j=0;j<32;j++)
		{
			if (j%8==0) printf(" ");
			printf("%c",_Memory[i][j]);
		}
		printf("\n");
	}
}


/************************ the end *********************************/


LinkingLoader::LinkingLoader() {
	CurSectNumber=-1;
	CurSection=NULL;
}

/************************ the end *********************************/

LinkingLoader::~LinkingLoader() {

}

/************************ the end *********************************/

void LinkingLoader::Reset() {
	CurSectNumber=-1;
	CurSection=NULL;
	StartAddress=ExecAddress;
}

/************************ the end *********************************/

char LinkingLoader::NextSection() {

	CurSectNumber++;
	if (CurSectNumber>=SectionCount) return FAIL;
	else CurSection=&Section[CurSectNumber];

	return SUCCESSFUL;
}


/************************ the end *********************************/

void LinkingLoader::Init(int numfiles,char *filenames[])
{
	Section=(struct SectionData *)malloc(numfiles*sizeof(struct SectionData));

	ExecAddress=StartAddress=0;
	Memory.StartAddress=StartAddress;
//	numfiles=4; /***???????*****/
	SectionCount=0;

	for(int i=0;i<numfiles;i++)
		if (filenames[i][0]=='-') 
		{
			ExecAddress=StartAddress=HexToInt(filenames[i]+1);
			Memory.StartAddress=StartAddress;
		}
		else
		{
			strcpy(Section[SectionCount++].SourceFileName,filenames[i]);
		}
	
	
	if (SectionCount==0) 
	{
		printf("usage: loader [ -startaddress(hexadecimal) ] filename1 filename2 ...\n");
		exit(1);
	}



	CurSectNumber=-1;
	CurSection=NULL;

}



/************************ the end *********************************/

char LinkingLoader::Pass1() {
	char RecType;

	Loader.Reset();
	while (NextSection()!=FAIL)
	{
		SrcFile.SetFileName(Loader.CurSection->SourceFileName);
		SrcFile.Open("r");
	
		if (SrcLine.New()==HEADER)
		{
			header.Read();
			header.Pass1();
		}
		else Error.SetErr(2,0);

		while ((RecType=SrcLine.New())!=END && RecType!=FAIL)
		{
			
			switch(RecType)
			{

			case DEFINE : 
				{
					define.Read();
					define.Pass1();
					break;
				}
			case REFERENCE :
				{
					reference.Read();
//					reference.Pass1();
					break;
				}
			case TEXT :
				{
					text.Read();
//					text.Pass1();
					break;
				}
			case MODIFY :
				{
					modify.Read();
//					modify.Pass1();
					break;
				}
			default : Error.SetErr(3,0);
			
			}

		}

		Loader.StartAddress+=Loader.CurSection->Length;
		Memory.EndAddress=Loader.StartAddress;
		SrcFile.Close();
	}

	return 0;

}


/************************ the end *********************************/

char LinkingLoader::Pass2() {
	char RecType;


	Memory.Init();
	Loader.Reset();
	while (NextSection()!=FAIL)
	{
		SrcFile.SetFileName(Loader.CurSection->SourceFileName);
		SrcFile.Open("r");
	
		if (SrcLine.New()==HEADER)
		{
			header.Read();
//			header.Pass2();
		}
		else Error.SetErr(2,0);

		while ((RecType=SrcLine.New())!=END && RecType!=FAIL)
		{
			
			switch(RecType)
			{

			case DEFINE : 
				{
					define.Read();
//					define.Pass2();
					break;
				}
			case REFERENCE :
				{
					reference.Read();
//					reference.Pass2();
					break;
				}
			case TEXT :
				{
					text.Read();
					text.Pass2();
					break;
				}
			case MODIFY :
				{
					modify.Read();
					modify.Pass2();
					break;
				}
			default : Error.SetErr(3,0);
			
			}

		}


		Loader.StartAddress+=Loader.CurSection->Length;
		SrcFile.Close();
	}

	return 0;
}






/************************ the end *********************************/

template<class DataStruct, int TableLength> int HashTable<DataStruct,TableLength>::_Hash(char *s) {

 char *p;
 unsigned int h=0,g;

 for(p=s;*p;p++)
 {
  h= (h << 4) + (*p);
  if ( (g = h & 0xf0000000))
  {
   h= h ^ (g >> 24);
   h= h ^ g;
  }
 }
// printf("hash= %d\n",h%TableLength);
 return h % TableLength;
}

/************************ the end *********************************/

template<class DataStruct,int TableLength> DataStruct *HashTable<DataStruct,TableLength>::Search(char *name) {
	int TableIndex;
	char Result;
	LinkedData<DataStruct> *Temp;
	
	TableIndex=_Hash(name);

	for(Temp=_Table[TableIndex];Temp!=NULL;Temp=Temp->Next)
       if (( Result=strcmp(name,Temp->Name) )==0) return &Temp->Data;

    return NULL;
}



/************************ the end *********************************/

template<class DataStruct, int TableLength> char HashTable<DataStruct,TableLength>::Insert(char *name,DataStruct data) {
	int TableIndex;
    LinkedData<DataStruct> *Current;
    LinkedData<DataStruct> *Previous;
	char Result;

	TableIndex=_Hash(name);
	
	for(Previous=Current=_Table[TableIndex];Current!=NULL;Previous=Current,Current=Current->Next)
	if (( Result=strcmp(name,Current->Name) )==0 ) return FAIL;
		else if (Result < 0) break;

	Current=(LinkedData<DataStruct> *)malloc(sizeof(LinkedData<DataStruct>));
	strncpy(Current->Name,name,MAX_SYMBOL_LENGTH-1);
	Current->Data=data;                
    
	if (Previous==NULL) {
		_Table[TableIndex]=Current;
		Current->Next=NULL;
	}
	else {
		Current->Next=Previous->Next;
		Previous->Next=Current;
	}

	return SUCCESSFUL;
} 


/************************ the end *********************************/

template<class DataStruct,int TableLength> void HashTable<DataStruct,TableLength>::Print() {
	LinkedData<DataStruct> *temp;

	for(int printed=0,i=0;i<TableLength;i++) {
		if (_Table[i]!=NULL) printf("%d= ", i);
		for(temp=_Table[i];temp!=NULL;temp=temp->Next) {
			printed++; 
			printf("%s",temp->Name);
			if (sizeof(temp->Data)==sizeof(int)) printf(",%d ",temp->Data);
			else printf(" - ");

		}
		
		if (printed>0) {printf("\n");printed=0;}	
	}
}

/************************ the end *********************************/

char ExternalSymbolTable::Insert(char *name,int address,int section){
	ExternalSymbolData data;

	data.Address=address;
	data.Section=section;

	return HashTable<ExternalSymbolData,EXT_SYMBOL_TABLE_LENGTH>::Insert(name,data);
}


/************************ the end *********************************/

void ExternalSymbolTable::Print(){
	LinkedData<struct ExternalSymbolData> *temp;

	for(int k=0;k<Loader.SectionCount;k++) 
	{
		printf("-------***%s***--------\n",Loader.Section[k].Name);
		for(int printed=0,i=0;i<EXT_SYMBOL_TABLE_LENGTH;i++) 
		{

			for(temp=_Table[i];temp!=NULL;temp=temp->Next) 
			{
				if (temp->Data.Section==k)
				{
					printed++; 
					printf("%s,%s",temp->Name,IntToHex(temp->Data.Address,4));
					printf(" - ");
				}

			}
			
			if (printed>0) {printf("\n");printed=0;}	
		}
	}
}

/************************ the end *********************************/

template<class DataStruct,int TableLength> HashTable<DataStruct,TableLength>::HashTable() {
	for(int i=0;i<TableLength;i++) _Table[i]=NULL;
}

/************************ the end *********************************/

template<class DataStruct,int TableLength> HashTable<DataStruct,TableLength>::~HashTable() {
	LinkedData<DataStruct> *cur, *prev;

	for(int i=0;i<TableLength;i++) 
	{   prev=NULL;
		while (prev!=_Table[i])
		{
			for(prev=cur=_Table[i];cur->Next!=NULL;prev=cur,cur=cur->Next); 
			prev->Next=NULL;
			free(cur);
		}
	}
	
}



/************************ the end *********************************/

void main(int argc, char *argv[]){

/*
	 
	argv[1]=(char *)malloc(2*sizeof(char));
	strcpy(argv[1],"-4000");
	argv[2]=(char *)malloc(5*sizeof(char));
	strcpy(argv[2],"proga");
	argv[3]=(char *)malloc(5*sizeof(char));
	strcpy(argv[3],"progb");
	argv[4]=(char *)malloc(5*sizeof(char));
	strcpy(argv[4],"progc");
	 

	 printf("%d %d %d\n",strlen(argv[1]),strlen(argv[2]),strlen(argv[3]));

*/
	Loader.Init(argc-1,&argv[1]);


	Loader.Pass1();

	Loader.Pass2();

	Memory.Print();
	ExtTable.Print();

}
