                              /* murat demirsoy-e1061548 */

#include <iostream.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define SUCCESSFUL 1
#define FAIL       0
#define ERROR      2

#define TRUE       1
#define FALSE      0

#define EOFILE     -1

#define HEADER       10
#define DEFINE       11
#define REFERENCE    12
#define TEXT         13
#define MODIFY       14
#define END          15


#define MAX_LINE_LENGTH       100	
#define MAX_RECORD_LENGTH     MAX_LINE_LENGTH
#define MAX_SYMBOL_LENGTH       7


#define EXT_SYMBOL_TABLE_LENGTH 50
#define ERROR_TABLE_LENGTH    100

#define MAX_SRCFILENAME_LENGTH 15
#define MAX_ERR_MESSAGE_SIZE  100
#define MAX_SECTION_NAME_LENGTH 6	



/****************** the end *********************/

class SourceFile {
protected:
	char SrcFileName[ MAX_SRCFILENAME_LENGTH ];
    FILE *_SrcFile;
public:
	void SetFileName(char *);
    char Open(char *mode);
	char Close();
	char Read(char *);
};
/****************** the end *********************/




class Errors {
private:
	int    _ErrNo;
	char   _ErrToken[ MAX_RECORD_LENGTH ];
	char * _ErrTable[ ERROR_TABLE_LENGTH ];
public:
    Errors();
   ~Errors();
    void SetErr(int errno, char *token);
    void Print();
};


/****************** the end *********************/

class MemoryClass {
private:
	int PC;

	char (*_Memory)[32];
public:
	int   StartAddress;
	int   EndAddress;
	void  Init();
	void  Write(int address,char numhalfbytes,char *data);
	char *Read(int address,char numhalfbytes);
	void  Print();

};

/****************** the end *********************/

class BaseRecord {
	friend void Errors::Print();
	friend void MemoryClass::Print();
	friend void MemoryClass::Write(int,char,char *);
	
private:

	char _ColCtr;
	char _Record[ MAX_RECORD_LENGTH ];
	void _ToUpper();
	
protected:
	int   AsInt(int);
	char *AsChar(int);
	char  Finished();

	char  _Error(int);

public:
	char Read();
};


/****************** the end *********************/


class SourceLine {
	friend char BaseRecord::Read();

private:
	char    _Line[ MAX_LINE_LENGTH ];
public:
    char New();
};



/****************** the end *********************/

class Header : public BaseRecord {
private : 
	void _SectionName(char *);
	int  _SectionAddress();
	int  _SectionLength();
public :
	char Pass1();
};



/****************** the end *********************/

class Define : public BaseRecord {
private:
	char _Symbol[6];
	int _Address;
	char _ColCtr;
	char _NextSymbol();

public :
	char Pass1();

};

/****************** the end *********************/

class Reference: public BaseRecord {
/* just Read and skip */
};

/****************** the end *********************/

class Text : public BaseRecord {
public:
	char Pass2();
};

/****************** the end *********************/

class Modify : public BaseRecord {
public:
	char Pass2();
};


/****************** the end *********************/


template<class DataStruct> struct LinkedData{ 
	char         Name[ MAX_SYMBOL_LENGTH ];
    DataStruct   Data;
	LinkedData<DataStruct> *Next;

};


/****************** the end *********************/


template< class DataStruct,int TableLength > class HashTable {
protected: 
	LinkedData<DataStruct> *_Table[TableLength];
	int _Hash(char *);
public:
	HashTable();
   ~HashTable();
	char        Insert(char *, DataStruct);
	DataStruct  *Search(char *);
	void        Print();
	
};


/****************** the end *********************/


struct ExternalSymbolData {
	int  Address;
	char Section;
};




class ExternalSymbolTable : public HashTable< ExternalSymbolData, EXT_SYMBOL_TABLE_LENGTH > {
public:
	char Insert(char *,int,int);
	void Print();
};



/****************** the end *********************/

struct SectionData {
	char SourceFileName[MAX_SRCFILENAME_LENGTH];
	char Name[6/* MAX_SECTION_NAME_LENGTH */];
	int  Address;
	int  Length;
};




class LinkingLoader {
    friend char Header::Pass1();
	friend void Errors::Print();
	friend void ExternalSymbolTable::Print();
	friend char SourceLine::New();
private:	
	int    Line;
	char   SectionCount;
	int    ExecAddress;

	struct SectionData *Section;
	Header header;
	Define define;
	Reference reference;
	Text   text;
	Modify modify;
protected:	
	
public:
	LinkingLoader();
   ~LinkingLoader();
	
    int    StartAddress;
	char   CurSectNumber;
   	struct SectionData *CurSection;
	void Reset();
	void Init(int,char*[]);
	char NextSection();
	char Pass1();
	char Pass2();
};


int HexToInt(char *);
char *IntToHex(int,char);


