
/******************N.Gokhan KURT - 1097625 *******************/


#include <stdlib.h>
#include <math.h>
#include <stdio.h>
#include <string.h>
#include <string>
#include <iostream>
#include <fstream>  
#define MAX_SYMBOLS 1024
#define MAX_FILES 16
#define MEMORY_SIZE 36000
#define UNASSIGNED -1

//------------------------------------------------------------------------
class ESTAB
 {public:     
      struct byte { string name;
                    int adress;
                  };
      byte estab[MAX_SYMBOLS];
      int cur_no_sym;

   //public:     

      void insert(string , int);
      int get(string);              
      ESTAB() {cur_no_sym=0;};  


 } ESTAB;

void ESTAB::insert(string name , int adress)
 {
  int i=0;

  for(i=0;i<cur_no_sym;i++)
   {
    if(estab[i].name==name) 
      { cout << "already defined : " << name << '\n';
        exit(1);
      }
   }
  
  estab[cur_no_sym].name=name;
  estab[cur_no_sym].adress=adress;
  cur_no_sym++;
 }

int ESTAB::get(string name)
 {
  int i=0;
 
  for(i=0;i<cur_no_sym;i++)
   {
    if(estab[i].name==name)
     { return estab[i].adress;
     }
   }
  
  cout << "no such symbol : " << name << '\n';
  exit(1);
 }
      
//----------------------------------------------------------------------------  
int CSADDR=0;
int PROGADDR=0;
int EXECADDR=0;
int CSLTH=0;
FILE * files[MAX_FILES]; 
int no_of_files=0;
 
void Pass1(void)
 {
  int i=0,p=0,j=0;
  FILE  * fp;
  int cur_file=0; 
  char c;
  string s;
 
  cout << "where to load the program in memory = ";
  cin >> PROGADDR ;
  CSADDR=PROGADDR;

  while(cur_file<no_of_files)
   {
     fp=files[cur_file++];
    
     if((c=getc(fp))!='H')   //Header record 
      { cout << "wrong format" << '\n';  
        exit(1);
      }
   
     for(i=0,s="";i<6;i++)  //program(control section) name 
      {
       if((c=getc(fp))==' ') continue;
        else s+=c;
      }   
     for(i=0;i<5;i++)  //start adress
      {
       if((c=getc(fp))!='0') 
        { cout << "start adress should be zero" << '\n';
          exit(1);
        }
      }

     fscanf(fp,"%x ",&CSLTH);  //length of program(control section)
     
     ESTAB.insert(s,CSADDR); 

     while((c=getc(fp))!='E')
      {
        if(c=='D')
         { 
          while(1)
           {
             for(i=0,s="";i<6;i++)  //symbol name
              {
                if((c=getc(fp))==' ') continue;
                else if(c=='\n') j=1;
                else s+=c;
              }   
             if(j) break;
             for(i=0,p=0;i<6;i++)  //start adress
              { p*=16; 
                c=getc(fp);
                if(c>=0x30 && c<=0x39)
                 { p+=c-0x30; continue;
                 }
                else if(c>=0x41 && c<=0x46)
                 { p+=c-0x41+10; continue;
                 }
                else { cout << "wrong hex no" << c <<  '\n'; exit(1);}
              }
             ESTAB.insert(s,CSADDR+p);
           }
         }
        else break ;
      }
    CSADDR+=CSLTH;
  }
 }

//----------------------------------------------------------------------------  

short int memory[MEMORY_SIZE]; //in bytes
int memory_counter=0;
int adress=0;

void Pass2(void)
 {
  int i=0,j=0,t=0,p=0,k=0,sign=0;
  char c;
  string s;
  int cur_file=0;
  FILE * fp;
  //int mem_in_cs=0;

  EXECADDR=CSADDR=PROGADDR;

  while(cur_file<no_of_files)
   {
     fp=files[cur_file++];

      if((c=getc(fp))!='H')   //Header record
       { cout << "wrong format" << '\n';
         exit(1);
       }            
   
      for(i=0,s="";i<6;i++)  //program(control section) name
       {
        if((c=getc(fp))==' ') continue;
         else s+=c;
       }                

      for(i=0;i<5;i++)  //start adress
       {
        if((c=getc(fp))!='0')
         { cout << "start adress should be zero" << '\n';
           exit(1);
         }
       }           

      fscanf(fp,"%x ",&CSLTH);  //length of program(control section)         

      while ((c=getc(fp))!='E')
       {
         if(c=='D') //eleminate D rec
          {
           for(i=0;i<73;i++)
            { if(getc(fp)=='\n') break;
            }
          }
         
         else if(c=='R') //eleminate R rec
          {
           for(i=0;i<73;i++)
            { if(getc(fp)=='\n') break; 
            }
          }

         else if(c=='T')
          {
           for(i=0,p=0;i<6;i++) //starting adress of T rec
            {
             p*=16;
             c=getc(fp);
             if(c>=0x30 && c<=0x39)
              { p+=c-0x30; continue;
              }
             else if(c>=0x41 && c<=0x46)
              { p+=c-0x41+10; continue;
              }
             else { cout << "wrong hex no" << c <<  '\n'; exit(1);}     
            }             
  
           for(;(p+CSADDR-PROGADDR)!=memory_counter;) //fill unassigned memory locations in 
            {                                //the object code
             memory[memory_counter++]=UNASSIGNED;
            }

           getc(fp);getc(fp);//length of T rec

           for(i=0,k=0;i<60;i++)
            {
             j=getc(fp);           //get one byte of T rec
             if(j=='\n') {k=1;break;} //if T rec ended
             if(j>=0x30 && j<=0x39)
              { j=j-0x30; }
             else if(j>=0x41 && j<=0x46)
              { j=j-0x41+10; }
             j*=16;
             t=getc(fp);
             if(t=='\n') {cout << "not even number of T rec entries "; exit(1);}
             if(t>=0x30 && t<=0x39)
              { t=t-0x30; }
             else if(t>=0x41 && t<=0x46)
              { t=t-0x41+10; }
          
             j+=t;

             memory[CSADDR+p+i-PROGADDR]=j;
             memory_counter++;
            }

          if(k)  continue;
         }

        else if(c=='M')
         {
          for(i=0,p=0;i<6;i++) //starting adress of the record
           { p*=16;            //to be modified (p)
             c=getc(fp);
             if(c>=0x30 && c<=0x39)
              { p+=c-0x30; continue;
              }
             else if(c>=0x41 && c<=0x46)
              { p+=c-0x41+10; continue;
              }
             else { cout << "wrong hex no" << c <<  '\n'; exit(1);}  
           }
          
           j=getc(fp);            //lenght of field to be modified
           if(j>=0x30 && j<=0x39) //in half bytes (j)
            { j=j-0x30; }
           else if(j>=0x41 && j<=0x46)
            { j=j-0x41+10; }
           j*=16;
           t=getc(fp);
           if(t>=0x30 && t<=0x39)
            { t=t-0x30; }
           else if(t>=0x41 && t<=0x46)
            { t=t-0x41+10; }
           j+=t;            

          sign=getc(fp);  //get sign in M rec

          for(i=0,s="";i<8;i++)  //get name of symbol (s)
           {
            if((c=getc(fp))==' ') continue;
            else if(c=='\n') break;
            else s+=c;
           }

          adress=ESTAB.get(s); //the number to be added or subtructed

          p=p+CSADDR+1; //starting adress of rec to be modified in memory[]

          if(j%2) j++; //if odd length add 1
          j=j/2;

          for(i=0,k=0;i!=j-1;i++) //current content of field to be modified  
           { k*=16*16;
             k+=memory[p+i-PROGADDR];
           }

          if(sign=='-') {k-=adress;}
          else if(sign=='+') {k+=adress;}

          for (i=j-2;i!=-1;i--)
           {
            memory[p+i-PROGADDR]=k%256;
            k/=256;
           }
       /*
          for(i=0;i!=j-1;i++)
           { memory[p+i-PROGADDR]=k/16;
             k=k%16;
           }
       */
        }

      }
     CSADDR+=CSLTH;
   
   }


 }

//----------------------------------------------------------------------------  

main(int argc , char * argv[])
{
 int i,k;

 for(i=1;i<argc;i++)
  {
   files[no_of_files++]=fopen(argv[i],"r");
  }

 Pass1();
 cout << "\n:::::::ESTAB:::::::\n";
  for(i=0;i<ESTAB.cur_no_sym;i++)
   {
     cout << ESTAB.estab[i].name << " : " << ESTAB.estab[i].adress << '\n';
   }

 cout << "::::::::::::::::::\n";

 for(i=1,no_of_files=0;i<argc;i++)
  {
   fclose(files[no_of_files]);
   files[no_of_files++]=fopen(argv[i],"r");
  }

 Pass2();


 std::ofstream from("memory.map");

  for(i=0,k=0;i<memory_counter;i++,k++)
   {
     if(k==0)
      {from << '\n' <<  hex << i+PROGADDR << " : " ; i-- ; continue;}
     if(k==32)
      {k=-1; i--; continue;}
     if(memory[i]==-1) {from << "XX"; continue;}                            
     if(memory[i] <= 0xF) { from << '0' ;}
     from << hex << memory[i];
      
   }

}

